Subject: Re: bug#45854: 28.0.50; [feature/native-comp] autoload behavior different in the presence of errors

From: Mauricio Collares <[email-masked]>
Date: Mon, 18 Jan 2021 09:36:45 -0300

Andrea Corallo <[email-masked]> writes:
>
> Hi Mauricio,
>
> I failed to reproduce on latest native-comp 88100bed0a.  Either I missed
> somenthing or is maybe fixed by the latest merge?
>
> Could you check if you still see this?
>

Hi Andrea,

Thanks for taking a look at this. I tested 883d937320 and although the
comp-enable-subr-trampolines bugs is fixed (many thanks!), I can still
reproduce this, both with the testcase from the first email
(comented-out "(provide 'transientx)") and with the testcase from the
second email (empty comp-eln-load-path + comp-enable-subr-trampolines
enabled by default). Any of those two errors then causes the following
error:

  error("%s is already defined as something else than a gen..."
  transient--init-suffix-key)

Is there any other information I can provide to help figure out why we
get different behaviour? I will include random ideas below, just in case.

The two commands I mentioned above install stuff in ~/.emacs.d/elpa (the
"git-commitx-20210102.1242" and "transientx-0" directories). Could it be
that your test succeeds because it is reusing files generated by a
different emacs version? In the first testcase, this is supposed to
apear right before the transient--init-suffix-key error:

  INFO     Scraping files for git-commitx-autoloads.el... 
  INFO     Scraping files for git-commitx-autoloads.el...done
Checking /home/collares/.emacs.d/elpa/git-commitx-20210102.1242...
Compiling /home/collares/.emacs.d/elpa/git-commitx-20210102.1242/git-commitx-autoloads.el...
Compiling /home/collares/.emacs.d/elpa/git-commitx-20210102.1242/git-commitx-pkg.el...
Compiling /home/collares/.emacs.d/elpa/git-commitx-20210102.1242/git-commitx.el...

In toplevel form:
git-commitx.el:6:1: Error: Loading file /home/collares/.emacs.d/elpa/transientx-0/transientx.elc failed to provide feature ‘transientx’
Done (Total of 0 files compiled, 1 failed, 2 skipped)

Best,
Mauricio